/*---------------------------------------------------------------------------
 * cgi.c Ver3.91
 * CGIėp[eBeB
 *
 * Last update : 1998/06/23
 *
 * Copyright(C) 1997-98  Yuto Ikeno  All rights reserved.
 * e-mail : mew@onbiz.net
 * homepage:http://xfiles.onbiz.net/~mew/
 * compile: gcc -c cgi.c
----------------------------------------------------------------------------*/

/*--- Define ---*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi.h"

/*--- Code ---*/
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint split (char *, char *, char)
@@@@Fchar *out		̒O܂łi[镶
@@@@@@@char *in		HΏە
@@@@@@@char search	
߂l@@@Fint			HΏە̏I[F0
@@@@Finsearch܂ŌAoutɑB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int split(char *out, char *in, char search){

	int i = 0,j = 0;
	int flag = 1;

	while(in[i] != search && in[i]){	/*searchɓ钼O܂ł̒l*outɑ */
		out[j] = in[i];
		i++; j++;
	}
	if(!in[i])/*Y镶*/
		flag = 0;
	
	out[j] = '\0';  /**out̍ŌNULL*/
	j =0;           /*JEgϐď*/
	i++;            /*search|C^i߂*/
	while(in[j]){   /*c̕A擪ɃVtg */
		in[j] = in[i];
		j++; i++;
	}
	return flag;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint substring (char *, int, int)
@@@@Fchar *out		Ώە
@@@@@@@int start		Jnʒu
@@@@@@@int end		Iʒu
߂l@@@Fchar *		instartend܂ł̕
@@@@Finstartend܂łout֔oB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *substring(char *in, int start, int end){

	int i,j;
	char *out;
	
	out = (char *)malloc(strlen(in) + 1);

	if(in[0] == '\n')
		return in;

	for(i = start, j = 0; i < end; i++, j++)  /*startend܂ł̕擾*/
		out[j] = in[i];

	out[j] = '\0';

	return out;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *replacestring (char *, int, int)
@@@@Fchar *in		uΏە
@@@@@@@char search	
@@@@@@@char *replace	u
߂l@@@Fchar *		uI̕ւ̃|C^
@@@@FinsearchAreplaceɒuB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *replacestring(char *in, char *search, char *replace){

	int		i,j,k,l,m;
	int		search_length, replace_length, replace_search;
	char	*buffer;
	char	*out;

	search_length = strlen(search);
	replace_length = strlen(replace);
	if(search_length == 0)
		return NULL;
	
	replace_length = replace_length + (replace_length % search_length);
	replace_search = replace_length / search_length;

	buffer = (char *)malloc(strlen(in) * (replace_search + 1));
	out = (char *)malloc(strlen(in) * (replace_search + 1));

	strcpy(buffer,in);
	k = 0;
	while(1){
		for(j = 0; *(buffer + k) && *(search + j);){
			if(*(buffer + k) == *(search + j))	/*vĂꍇ*/
				k++, j++;
			else	/*vȂꍇ*/
				k++;
		}
		if(j == 0)/*͕񒆂Ɍ񂪑݂Ȃꍇ*/
			break;
		for(l = 0, i = 0; i < (k - search_length); i++, l++)/*͕񒆂Ō񂪌܂*/
			out[l] = buffer[i];
		for(m = 0; *(replace + m); m++, l++)/*u*/
			out[l] = replace[m];

		i += search_length;

		for( ; *(buffer + i); i++, l++)/*͕񒆂̌ȍ~*/
			out[l] = buffer[i];
		out[l] = '\0';
		strcpy(buffer,out);

		if(!*(buffer + k + (replace_length - search_length)))
			break;
	}
	free(out);
	
	return buffer;
}

char tochar(char *x){

	register char c;

	c  = (x[0] >= 'A' ? ((x[0] & 0xdf) - 'A') + 10 : (x[0] - '0'));
	c *= 16;
	c += (x[1] >= 'A' ? ((x[1] & 0xdf) - 'A') + 10 : (x[1] - '0'));
	return(c);
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid decode(char *)
@@@@Fchar *url		GR[hꂽ
@@@@FurlfR[hB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void decode(char *url){

	register int i, j;

	for(i = 0, j = 0; url[j]; ++i, ++j){
		if((url[i] = url[j]) == '%'){
			url[i] = tochar(&url[j + 1]);
			j += 2;
		}
		else if (url[i] == '+')
		url[i] = ' ';
	}
	url[i] = '\0';
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint getdata (char ***, char ***)
@@@@Fchar ***dname		tH[f[^namemۂ邽߂̗̈ւ̃|C^
@@@@@@@char ***dvalue	tH[f[^valuemۂ邽߂̗̈ւ̃|C^
߂l@@@Fint				name=valluȇg
@@@@FtH[̃f[^󂯎AnamevalueɕB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int getdata(char ***dname, char ***dvalue){

	char *qstring;			/*stdin data*/
	char *qs;
	char *method;			/*REQUEST_METHOD*/
	int ictl;				/*CONTENT_LENGTH*/
	int i;					/*JE^*/
	int count;				/*ddname=dvaluȇg*/
	char **tmpnam,**tmpval;	/*dnamedvaluei[Qz*/

	method = getenv("REQUEST_METHOD");	/*𒲂ׂ*/
	if(method == NULL){
		return -1;
	}else if(!strcmp(method, "POST")){	/*POST̎*/

		ictl = atoi(getenv("CONTENT_LENGTH"));
		if(ictl == 0)/*󂯎f[^݂Ȃ*/
			return -1;
		if((qstring = (char *)malloc(ictl + 1)) == NULL)
			return -1;
		if((fread(qstring, ictl, 1, stdin)) != 1)
			return -1;
		qstring[ictl] = '\0';

	}else if(!strcmp(method, "GET")){			/*GET̎*/
		qs = getenv("QUERY_STRING");
		if(qs == NULL){
			return -1;
		}else{
			ictl = strlen(qs);
			if((qstring = (char *)malloc(sizeof(char) * (ictl + 1))) == NULL)
				return -1;
			strcpy(qstring,qs);
			if(*qstring == '\0')
				return 0;
		}
	}

	for(i = 0, count = 0; *(qstring + i + 1); i++){
		if(*(qstring + i) == '&')
			count++;
	}

	count++;
	tmpval = (char**)malloc(sizeof(char*) * count);
	tmpnam = (char**)malloc(sizeof(char*) * count);

	/*----- fR[h -----*/
	for(i = 0; i < count; i++){
		tmpval[i] = (char*)malloc(strlen(qstring));
		tmpnam[i] = (char*)malloc(strlen(qstring));
		split(*(tmpval + i), qstring, '&');
		decode(*(tmpval + i));
		split(*(tmpnam + i), *(tmpval + i), '=');
	}
	*dname = tmpnam;
	*dvalue = tmpval;

	return count;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint freedata (char **, char **, int)
@@@@Fchar **name	Ώۂ̓񎟔z
@@@@@@@char **value	Ώۂ̓񎟔z
@@@@@@@int count		name=valuȇg
@@@@FnamevaluẽB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void freedata(char **name, char **value, int count){
	
	int i;

	for(i = 0; i < count; i++){
		free(name[i]);
		free(value[i]);
	}
	free(name);
	free(value);
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint getcookiesdata (char ***, char ***, char *)
@@@@Fchar ***cname		cookienamemۂ邽߂̗̈ւ̃|C^
@@@@@@@char ***cvalue	cookienamemۂ邽߂̗̈ւ̃|C^
@@@@@@@char *name		擾cookie̖O
߂l@@@Fint				name=valuȇg
@@@@FnameŎw肳ꂽcookienamevalue𕪊i[B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int getcookiesdata(char ***cname, char ***cvalue, char *name){

	char *http_cookie;			/*HTTP_COOKIE*/
	char unknown[10] = "Unknown";
	char *cookie_value;			/*Cookie*/
	char *cookie_name;		/*Cookie's Name*/
	int i,j;				/*JE^*/
	int count = -1;				/*name=valuȇg*/
	char **tmpnam,**tmpval;	/*namevaluei[Qz*/
	char *buf_name;
	char *buf_http_cookie;
	int flag;

	if((http_cookie = getenv("HTTP_COOKIE")) == NULL){
		buf_http_cookie = unknown;
	}else{
		/*CookieH*/
		buf_name = (char *)malloc(strlen(name) + 2);
		sprintf(buf_name, " %s", name);		/*namebuf_nameɑޔA擪ɃXy[X*/
		buf_http_cookie = (char *)malloc(strlen(http_cookie) + 3);
		sprintf(buf_http_cookie, " %s;", http_cookie);		/*http_cookiebuf_http_cookieɑޔA擪ɃXy[X*/

		if(strstr(buf_http_cookie, buf_name) != NULL){
			cookie_value = (char *)malloc(strlen(buf_http_cookie));
			cookie_name = (char *)malloc(strlen(buf_http_cookie));

			for(i = 0; ; i++){
				flag = split(cookie_value,buf_http_cookie,';');
				split(cookie_name,cookie_value,'=');
				if(!strcmp(cookie_name,buf_name)){
					for(i = 0, count = 0; *(cookie_value + i + 1); i++){
						if(*(cookie_value + i) == '^')
							count++;
					}
					count++;
					tmpval = (char**)malloc(sizeof(char*) * count);
					tmpnam = (char**)malloc(sizeof(char*) * count);
					for(j = 0; j < count; j++){
						tmpval[j] = (char*)malloc(strlen(cookie_value));
						split(*(tmpval + j), cookie_value, '^');
						tmpnam[j] = (char*)malloc(strlen(*(tmpval + j)));
						split(*(tmpnam + j), *(tmpval + j), '*');
					}
					*cname = tmpnam;
					*cvalue = tmpval;
					break;
				}else{
					if(flag == 0)
						break;
				}
			}
			free(cookie_value);
			free(cookie_name);
			free(buf_http_cookie);
			free(buf_name);
		}
	}
	return count;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid fatal_error (const char *, const char *)
@@@@Fconst char *message		G[bZ[WƂďo͂镶
@@@@@@@const char *body			HTMLBODY
@@@@FmessageŎw肵G[bZ[WBODY̐Fy[W֕\AexitB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void fatal_error(const char* message, const char* body){
	
	puts("Content-Type: text/html\n");
	puts("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">"
		"<HTML><HEAD><TITLE>vIG[</TITLE></HEAD>");
	puts(body);
	puts("<BLOCKQUOTE><BR><BR>");
	puts(message);
	puts("</BLOCKQUOTE></BODY></HTML>");
	
	exit(1);

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint get_int_count (const char *)
@@@@Fconst char *filename	Ώۂ̃t@C
߂l@@@Fint					擾JE^
@@@@Ffilenameint^̐ǂݍݕԂB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int get_int_count(const char* file_path){

	int count;
	char buf[6];
	FILE *fp;
	
	if((fp = fopen(file_path,"r")) == NULL)
		fatal_error("JE^[t@CJ܂","<BODY>");

	fgets(buf,6,fp);
	count = atoi(buf);
	fclose(fp);

	return count;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid put_int_count (const char *, int)
@@@@Fconst char *filename	Ώۂ̃t@C
@@@@@@@int count				int^̐
@@@@FfilenameŎw肳ꂽt@CcountށB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void put_int_count(const char* file_path, int count){

	FILE *fp;
	
	if((fp = fopen(file_path,"w")) == NULL)
		fatal_error("JE^[t@CJ܂","<BODY>");

	fprintf(fp,"%05ld\n",(count+1));
	fclose(fp);

	return;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFcheck_string (char *, char)
@@@@Fchar *sinput		Ώۂ̕
@@@@@@@char checkword	
߂l@@@Fint				Ȃ̃tO
@@@@FF0@ȂF1
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int check_string(char *sinput, char checkword){
	
	int i;
	
	for(i = 0; *(sinput + i); i++){
		if(*(sinput + i) == checkword)/**/
			return 0;
	}
	return 1;	/*Ȃ*/
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *check_url (char *)
@@@@Fchar *url		`FbNΏۂURL
߂l@@@Fchar *		`FbN̕
@@@@Furl`ł邩ׁAurlɃXy[X܂܂ꍇ͏B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *check_url(char *url){

	int i;
	int count;
	
	i = 0;
	count = 0;
	while(url[i]){
		if(url[i] == '.')
			count++;
		i++;
	}
	if(i > 8){
		if(count < 1)
			fatal_error(" URĽ``Ⴂ܂BxAm߂B","<body>");
		if(check_string(url,'/') == 1)
			fatal_error(" URĽ``Ⴂ܂BxAm߂B","<body>");
		if(check_string(url,',') == 0)
			fatal_error(" URĽ``Ⴂ܂BxAm߂B","<body>");
		url = replacestring(url," ","");/*URL̃Xy[X菜*/
	}
	return url;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint delline (char *, unsigned int)
@@@@Fchar *filename	ΏۂƂȂt@C
@@@@@@@unsigned int 		zXg
@@@@Fw肳ꂽt@C̎ws폜
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int delline(char *filename, unsigned int line_number){

	FILE	*fp;
	FILE	*fp_temp;
	int		i;
	char	buf[BUFSIZE];
	char	buf_temp[BUFSIZE];

	
	if((fp = fopen(filename, "r")) == NULL)
		return 1;

	if((fp_temp = fopen("./file/temp", "w")) == NULL)
		fatal_error(" 炩̃G[܂B-2","<BODY>");

	for (i = 1; ; i++){
		if(fgets(buf, BUFSIZE, fp) == NULL)
			break;
		if(i != line_number)
			fputs(buf,fp_temp);
	}
	unlink(filename);
	if(rename("./file/temp", filename) != 0){
		fclose(fp);
		fclose(fp_temp);
		fatal_error(" 炩̃G[܂B-3", "<BODY>");
	}
	fclose(fp);
	fclose(fp_temp);
	return 0;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint addline (char *, char *)
@@@@Fchar *filename		ΏۂƂȂt@C
@@@@@@@char *host_name 		zXg
@@@@Fw肳ꂽt@Cɍڂǉ
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int addline(char *filename, char *host_name){

	FILE	*fp;
	int		i;

	if((fp = fopen(filename, "a")) == NULL)
		return 1;

	fprintf(fp,"%s\n",host_name);
	fclose(fp);

	return 0;
}
/*End of file*/