/*---------------------------------------------------------------------------
 * mewCounter.cgi Ver1.11
 * OtBbNA^JE^[
 * for UNIX
 *
 * Last modified 1997/06/30
 *
 * Copyright(C) 1997-98  Yuto Ikeno  All rights reserved.
 * e-mail:mew@onbiz.net
 * homepage:http://www.onbiz.net/~mew/
 * compile:gcc -o mewcounter.cgi mewcounter.c cgi.o -lgd -lm
 *-------------------------------------------------------------------------
 * This program needs 'gd Library'.
 * copyright 1994, 1995
 * Quest Protein Database Center, Cold Spring Harbor Labs
 * Tom Boutell
 * http://www.boutell.com/gd/
 *-------------------------------------------------------------------------*/

/*-- Define --*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>
#include "cgi.h"
#include "mewcounter.h"
#include "gd/gd.h"

/*--- Vars ---*/
struct stat fs;

/*--- Cords ---*/

/*--- JE^t@C̓ǂݍ݂Ə ---*/
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFlong int getCounter(char *)
߂l@@@Flong int			擾JE^[l
@@@@Fchar *user		擾Ώۂ̃[U
@@@@FuserŎw肳JE^[t@C̃JE^[l擾
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
long int counter(char *user){
	
	long int	icount;
	char		buffer[BUFSIZE];
	char		fname[100];
	FILE		*count_fp;

	sprintf(fname,"%s%s",PATH_USERFILE,user);
	if((count_fp = fopen(fname,"r")) == NULL)
		fatal_error("JE^[t@Cǂݍ߂܂łBt@C݂ȂANobodyɓǂݍ݌^Ă܂B","<BODY>");

	fgets(buffer,BUFSIZE,count_fp);
	fclose(count_fp);

	icount = atol(buffer);

	if((count_fp = fopen(fname,"w")) == NULL)
		fatal_error("JE^[t@Cɏ߂܂łBt@C݂ȂANobodyɏ݌^Ă܂B","<BODY>");
	fprintf(count_fp,"%ld\n",icount + 1);
	fclose(count_fp);
	return icount;
}

/*--- 摜Wo͂ɏo ---*/
int put_image(char image_type, char *sinput, int width){
	
	int i;					/*JE^[p*/
	int putwidth;			/*A摜̉*/
	int ilen;				/*sinput̒ - 1*/
	long int flen = 0;		/*摜̃t@CTCY*/
	char fname[100];		/*JE^[摜t@C̃pX*/
	char *buffer;
	char zero[100];
	FILE *fp;
	gdImagePtr imgout, imgin;

	ilen = strlen(sinput) - 1;
	
	if(width > ilen){
		if((buffer = (char *)malloc(sizeof(char) * (strlen(sinput) + 1))) == NULL){
			puts("Content-type: text/html\n\n");
			puts("[̊mۂɎs܂B");
			return 1;
		}
		strcpy(buffer,sinput);
		for(i = 0; i < (width - ilen - 1); i++){
			zero[i] = '0';
		}
		zero[i] = '\0';
		strcpy(sinput, zero);
		strcat(sinput, buffer);
		free(buffer);
	}

	putwidth = IMAGE_WIDTH * strlen(sinput);
	imgout = gdImageCreate(putwidth,IMAGE_HEIGHT);

	for(i = 0; *(sinput + i); i++){
		sprintf(fname,"%s%c/%c.gif",PATH_IMAGE,image_type,*(sinput + i));
		stat(fname,&fs);
		flen = flen + (long int)fs.st_size;
		if((fp = fopen(fname, "rb")) == NULL){
			puts("Content-type: text/html\n\n");
			puts("摜t@Cǂݍ߂܂");
			return 1;
		}else{
			imgin = gdImageCreateFromGif(fp);
			fclose(fp);
			gdImageCopy(imgout, imgin, i * IMAGE_WIDTH, 0, 0, 0, IMAGE_WIDTH, IMAGE_HEIGHT);
		}
	}
	printf("Content-type: image/gif\nContent-length: %ld\n\n",flen);
	gdImageGif(imgout, stdout);
	fflush(stdout);
	gdImageDestroy(imgin);
	gdImageDestroy(imgout);

	return 0;
}

int main(void){
	
	int i;					/*JE^[p*/
	int handle;				
	int count;				/*name=valuȇg*/
	int width;				/*o͂錅*/
	char sinput[BUFSIZE];			/*摜ɂ镶*/
	char image_type;		/*摜̎*/
	char **name, **value;	/*GETŎ擾name=value*/
	char *user;			/*[U[iJE^[t@C̖Oj*/
	char fname_lock[100];
	FILE *fp;
	gdImagePtr imgout, imgin;

	count = getdata(&name,&value);
	for(i = 0; i < count; i++){
		if(!strcmp(*(name + i),"type"))
			image_type = **(value + i);
		else if(!strcmp(*(name + i),"user"))
			user = *(value + i);
		else if(!strcmp(*(name + i),"width"))
			width = atoi(*(value + i));
	}

	sprintf(fname_lock,"%s%slock",PATH_LOCK,user);
	i = 0;
	while(access(fname_lock,00) == 0){
		i++;
		if(i >= 30){
			puts("Content-type: text/html\n\n");
			puts("JE^[t@CbNĂ܂B");
			return 0;
		}
		sleep(1);
	}
	if((handle = open(fname_lock, O_CREAT,S_IREAD|S_IWRITE)) == -1)
		fatal_error("t@C̍쐬Ɏs܂","<BODY>");

	sprintf(sinput, "%ld", counter(user));
	close(handle);
	unlink(fname_lock);		/*IɃbNt@C폜*/
	if(put_image(image_type, sinput, width))
		return 1;

	freedata(name, value, count);/*[*/
	return 0;
}